#!/usr/bin/env bash

working_dir="$(dirname $(realpath $0))"

user_name=sysadm
user_uid=1050
user_gid=1050

echo "$user_name:test100:${user_uid}:${user_gid}:${user_name},,,:/home/${user_name}:/bin/bash" | newusers
perl -i -n -p -e "s#^(${user_name}):[^:]+:(.+)#\1:\\\$6\\\$vvccwrTc\\\$Sz1HaSb3ujObprltiG7D6U1Rr3fpgfjkKuDDWYdHzPkPx/0pEofCWC.vyTn78hcemkntl.6wVUOnJnNloKt/E/:\2#" /etc/shadow
cd /home/${user_name}
if [[ -f "/home/${user_name}/.bashrc" ]] ; then
   mv "/home/${user_name}/.bashrc" "/home/${user_name}/.bashrc.ORIG"
fi
if [[ -f "/home/${user_name}/.profile" ]] ; then
   mv "/home/${user_name}/.profile" "/home/${user_name}/.profile.ORIG"
fi

if [[ -d "${working_dir}/../templates_${user_name}" ]]; then
   if [[ -f "${working_dir}/../templates_${user_name}/.bashrc" ]] ; then
      cp -a "${working_dir}/../templates_${user_name}/.bashrc" "/home/${user_name}/"
      chown ${user_name}:${user_name} "/home/${user_name}/.bashrc"
   fi
   if [[ -f "${working_dir}/../templates_${user_name}/.bash_logout" ]] ; then
      cp -a "${working_dir}/../templates_${user_name}/.bash_logout" "/home/${user_name}/"
      chown ${user_name}:${user_name} "/home/${user_name}/.bash_logout"
   fi
   if [[ -f "${working_dir}/../templates_${user_name}/.profile" ]] ; then
      cp -a "${working_dir}/../templates_${user_name}/.profile" "/home/${user_name}/"
      chown ${user_name}:${user_name} "/home/${user_name}/.profile"
   fi
   if [[ -f "${working_dir}/../templates_${user_name}/.vimrc" ]] ; then
      cp -a "${working_dir}/../templates_${user_name}/.vimrc" "/home/${user_name}/"
      chown ${user_name}:${user_name} "/home/${user_name}/.vimrc"
   fi
   if [[ -d "${working_dir}/../templates_${user_name}/.ssh" ]] ; then
      mkdir  /home/${user_name}/.ssh
      if [[ -f "${working_dir}/../templates_${user_name}/.ssh/authorized_keys2" ]] ; then
         cp -a "${working_dir}/../templates_${user_name}/.ssh/authorized_keys2" "/home/${user_name}/.ssh"
      elif [[ -f "${working_dir}/../templates_${user_name}/.ssh/authorized_keys" ]] ; then
         cp -a "${working_dir}/../templates_${user_name}/.ssh/authorized_keys" "/home/${user_name}/.ssh"
      fi
      chmod 700 /home/${user_name}/.ssh
      chown -R ${user_name}:${user_name} /home/${user_name}/.ssh
   fi
fi

usermod -a -G sudo ${user_name}
ls -al /home/${user_name}/.ssh

exit
